//M9.cs

//audio
datablock AudioProfile(m9ShotSound)
{
   filename    = "./m9Shot.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(bulletHitSound)
{
   filename    = "Add-Ons/Weapon_Gun/bulletHit.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(magReloadSound)
{
   filename    = "./Reload.wav";
   description = AudioClose3d;
   preload = true;
};


//Magazine
datablock DebrisData(M9ShellDebris)
{
	shapeFile = "./mag.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ParticleData(M9FlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.9 0.0 0.9";
	colors[1]     = "0.9 0.5 0.0 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(M9FlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "M9FlashParticle";

   uiName = "M9 Flash";
};


datablock ParticleData(M9ExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.9 0.3";
	colors[1]     = "0.9 0.5 0.6 0.0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.75;

	useInvAlpha = true;
};

datablock ParticleEmitterData(M9ExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "M9ExplosionParticle";

   useEmitterColors = true;
   uiName = "M9 Hit Dust";
};

datablock ParticleData(M9ExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 0.0 0.9";
	colors[1]     = "0.9 0.0 0.0 0.0";
	sizes[0]      = 1;
	sizes[1]      = 0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(M9ExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "M9ExplosionRingParticle";

   useEmitterColors = true;
   uiName = "M9 Hit Flash";
};

datablock ExplosionData(M9Explosion)
{
   //explosionShape = "";
	soundProfile = bulletHitSound;

   lifeTimeMS = 150;

   particleEmitter = M9ExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = M9ExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};

AddDamageType("M9",   '<bitmap:add-ons/Weapon_Gun/CI_gun> %1',    '%2 <bitmap:add-ons/Weapon_Gun/CI_gun> %1',0.2,1);
datablock ProjectileData(M9Projectile)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 30;
   directDamageType    = $DamageType::M9;
   radiusDamageType    = $DamageType::M9;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 400;
   explosion           = M9Explosion;
   particleEmitter     = ""; //bulletTrailEmitter;

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "M9 Bullet";
};

//////////
// item //
//////////
datablock ItemData(M9PistolItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./M9.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "M9";
	iconName = "./icon_gun";
	doColorShift = true;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = M9Image;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(M9Image)
{
   // Basic Item properties
   shapeFile = "./M9.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = M9Projectile;
   projectileType = Projectile;

	casing = M9ShellDebris;
	shellExitDir        = "0 0 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = M9Item.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

  // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Reload";
	stateSound[0]					= magReloadSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Ammo1";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                     = "Reload";
	stateAllowImageChange[2]         = true;
	stateSequence[2]                = "Reload";
	stateScript[2]                  = "Reload";
	stateSequence[2]		= "Reload";
	stateTransitionOnTimeout[2]     = "Reload2";
	stateWaitForTimeout[2]			= true;
	stateTimeoutValue[2]				= 0.65;
	stateSound[2]					= M9ReloadSound;
	stateEjectShell[2]       = true;

	stateName[3]                     = "Reload2";
	stateAllowImageChange[3]         = true;
	stateSequence[3]                = "Reload";
	stateScript[3]                  = "Reload";
	stateSequence[3]	= "Reloadpart2";
	stateTransitionOnTimeout[3]     = "Ready";
	stateWaitForTimeout[3]			= true;
	stateTimeoutValue[3]				= 0.85;
	stateSound[3]					= M9Reload2Sound;

	stateName[4]                    = "Ammo1";
	stateTransitionOnTimeout[4]     = "Ammo1Ready";
	stateTimeoutValue[4]            = 0.54;
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
	stateSequence[4]                = "Fire";
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]			= true;
	stateEmitter[4]					= gunFlashEmitter;
	stateEmitterTime[4]				= 0.02;
	stateEmitterNode[4]				= "muzzleNode";
	stateSound[4]					= M9ShotSound;

	stateName[5]                     = "Ammo1Ready";
	stateTransitionOnTriggerDown[5]  = "Ammo2";
	stateAllowImageChange[5]         = true;
	stateSequence[5]	= "Ready";
	
	stateName[6]                    = "Ammo2";
	stateTransitionOnTimeout[6]     = "Ammo2Ready";
	stateTimeoutValue[6]            = 0.54;
	stateFire[6]                    = true;
	stateAllowImageChange[6]        = false;
	stateSequence[6]                = "Fire";
	stateScript[6]                  = "onFire";
	stateWaitForTimeout[6]			= true;
	stateEmitter[6]					= gunFlashEmitter;
	stateEmitterTime[6]				= 0.02;
	stateEmitterNode[6]				= "muzzleNode";
	stateSound[6]					= M9ShotSound;

	stateName[7]                     = "Ammo2Ready";
	stateTransitionOnTriggerDown[7]  = "Ammo3";
	stateAllowImageChange[7]         = true;
	stateSequence[7]	= "Ready";

	stateName[8]                    = "Ammo3";
	stateTransitionOnTimeout[8]     = "Ammo3Ready";
	stateTimeoutValue[8]            = 0.54;
	stateFire[8]                    = true;
	stateAllowImageChange[8]        = false;
	stateSequence[8]                = "Fire";
	stateScript[8]                  = "onFire";
	stateWaitForTimeout[8]			= true;
	stateEmitter[8]					= gunFlashEmitter;
	stateEmitterTime[8]				= 0.02;
	stateEmitterNode[8]				= "muzzleNode";
	stateSound[8]					= M9ShotSound;

	stateName[9]                     = "Ammo3Ready";
	stateTransitionOnTriggerDown[9]  = "Ammo4";
	stateAllowImageChange[9]         = true;
	stateSequence[9]	= "Ready";

	stateName[10]                    = "Ammo4";
	stateTransitionOnTimeout[10]     = "Ammo4Ready";
	stateTimeoutValue[10]            = 0.54;
	stateFire[10]                    = true;
	stateAllowImageChange[10]        = false;
	stateSequence[10]                = "Fire";
	stateScript[10]                  = "onFire";
	stateWaitForTimeout[10]			= true;
	stateEmitter[10]					= gunFlashEmitter;
	stateEmitterTime[10]				= 0.02;
	stateEmitterNode[10]				= "muzzleNode";
	stateSound[10]					= M9ShotSound;

	stateName[11]                     = "Ammo4Ready";
	stateTransitionOnTriggerDown[11]  = "Ammo5";
	stateAllowImageChange[11]         = true;
	stateSequence[11]	= "Ready";

	stateName[12]                    = "Ammo5";
	stateTransitionOnTimeout[12]     = "Ammo5Ready";
	stateTimeoutValue[12]            = 0.54;
	stateFire[12]                    = true;
	stateAllowImageChange[12]        = false;
	stateSequence[12]                = "Fire";
	stateScript[12]                  = "onFire";
	stateWaitForTimeout[12]			= true;
	stateEmitter[12]					= gunFlashEmitter;
	stateEmitterTime[12]				= 0.02;
	stateEmitterNode[12]				= "muzzleNode";
	stateSound[12]					= M9ShotSound;

	stateName[13]                     = "Ammo5Ready";
	stateTransitionOnTriggerDown[13]  = "Ammo6";
	stateAllowImageChange[13]         = true;
	stateSequence[13]	= "Ready";
	
	stateName[13]                    = "Ammo6";
	stateTransitionOnTimeout[13]     = "Ammo6Ready";
	stateTimeoutValue[13]            = 0.54;
	stateFire[13]                    = true;
	stateAllowImageChange[13]        = false;
	stateSequence[13]                = "Fire";
	stateScript[13]                  = "onFire";
	stateWaitForTimeout[13]			= true;
	stateEmitter[13]					= gunFlashEmitter;
	stateEmitterTime[13]				= 0.02;
	stateEmitterNode[13]				= "muzzleNode";
	stateSound[13]					= M9ShotSound;

	stateName[14]                     = "Ammo6Ready";
	stateTransitionOnTriggerDown[14]  = "Ammo7";
	stateAllowImageChange[14]         = true;
	stateSequence[14]	= "Ready";

	stateName[14]                    = "Ammo7";
	stateTransitionOnTimeout[14]     = "Reload";
	stateTimeoutValue[14]            = 0.34;
	stateFire[14]                    = true;
	stateAllowImageChange[14]        = false;
	stateSequence[14]                = "Fire";
	stateScript[14]                  = "onFire";
	stateWaitForTimeout[14]			= true;
	stateEmitter[14]					= gunFlashEmitter;
	stateEmitterTime[14]				= 0.02;
	stateEmitterNode[14]				= "muzzleNode";
	stateSound[14]					= M9ShotSound;
};

function M9Image::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, shiftAway);
	Parent::onFire(%this,%obj,%slot);	
}